#!perl5

use IceBearSoft::ZWurl(cgi_parse);

# Constants
$admin = 'Administrator';
$secdir = "$ENV{'SERVER_ROOT'}/security";
$user = $ENV{'REMOTE_USER'};
$usrfile = "$secdir/users";
$grpfile = "$secdir/groups";
$scheme = 'https://' if $ENV{'HTTPS'} eq 'on';
$scheme = 'http://' unless $scheme;
$pgm = 'wwwhtpasswd';

sub admin();
sub ChgPasswd($$$);
sub ListGroup($$);
sub AddToGroup($$$);
sub WriteGroup($$;$);

# Print the CGI header
$| = 1;
print<<EOD;
Content-Type: text/html

<html>
<head>
<title>Password Management</title>
EOD

$referer = $ENV{'HTTP_REFERER'};
$me = $ENV{'REQUEST_URI'};
$me = "$scheme$ENV{'SERVER_NAME'}$me" unless index($me, '$scheme') == 0;
if ($ENV{'REQUEST_METHOD'} != 'POST' || !$me || !$referer || index($me, $referer) < 0) {
$url = "$scheme$ENV{'SERVER_NAME'}/passwd/";
print<<"EOD";
<META HTTP-EQUIV=\"Refresh\" CONTENT=\"15; URL=$url\">
</head>
<body>
<p>Sorry, you can access this script through
<a href=\"$url\"><code>$url</code></a> only.
</body>
</html>
EOD
exit 0;
}

print<<EOD;
</head>
<body>
<h1>Password Management</h1>
EOD

if (!$user) {
  print "<P>The user name was not specified, your browser is broken.\n";
}
else {
  if ($user eq $admin) {
    admin;
  }
  else {
    %cgi = cgi_parse;
    print "<P>Changing password for <i>$user</i>.\n";
    $pass1 = $cgi{'Pass1'};
    $pass2 = $cgi{'Pass2'};
    ChgPasswd $user, $pass1, $pass2;
  }
}
print<<EOD;
</body>
</html>
EOD
exit 0;

sub admin {
my %cgi = cgi_parse;
my (%users, %groups);
my $function = $cgi{'function'};
my $grpcnt = 0;
my $usrcnt = 2;

# Input users

open(FILE, $usrfile) or die "<P>Cannot open $usrfile; $!";
while ($l = <FILE>) {
  if ($l =~ /^([^:]+):\s*(.*?)\s*$/) {
    $users{$1} = $2;  $usrcnt++;
  }
}
close FILE;

# Input groups

open(FILE, $grpfile) or die "<P>Cannot open $grpfile; $!";
while (chomp($l = <FILE>)) {
  if ($l =~ /^([^:]+):\s*(.*?)\s*$/) {
    my @array = split(/\s/,$2);
    $groups{$1} = \@array;
    $grpcnt++;
  }
}
close FILE;

if ($function) {

# Preparing the forms

print "<form method=POST action=\"$ENV{'REQUEST_URI'}\">\n";
FORM: {
if ($function eq 'NewUser') {
print<<"EOD";
<P>Enter a new user and his group(s):
<table>
<tr>
<td>User
<td>Group
<td>Password (twice)
<tr valign=top>
<td><input type=text name=\"userid\" size=16 maxlength=64>
<td rowspan=2><select multiple name=\"group\" size=$grpcnt>
EOD
foreach $g (sort(keys %groups)) {
  print "<option>$g</option>\n";
}
print<<"EOD";
</select>
<td><input type=password maxlength=128 size=32 name="Pass1">
<td><input type=submit name=\"$function\">
<tr valign=top><td><td>
<input type=password maxlength=128 size=32 name="Pass2">
</table>
EOD
last FORM;
}
if ($function eq 'ChgUser') {
print<<EOD;
<table>
<tr valign=middle>
<td align=right>User name
<td align=left><select name=userid size=1>
EOD
foreach $u (sort (keys %users)) {
  print "<option>$u</option>\n";
}
print<<EOD;
</select>
<tr valign=middle>
<td align=right>Type the new password
<td align=left><input type=password maxlength=128 size=32 name="Pass1">
<tr valign=middle>
<td align=right>Retype it here
<td align=left><input type=password maxlength=128 size=32 name="Pass2">
<tr><td><td align=left>
<input type=submit name=\"$function\">
</table>
EOD
last FORM;
}
if ($function eq 'ListGroups') {
  print "<P>List of groups:\n<pre>\n";
  foreach $g (keys %groups) {
    ListGroup $g, $groups{$g};
  }
  print "</pre>\n";
  last FORM;
}
if ($function eq 'NewGroup') {
print<<"EOD";
<P>Adding new group
<table>
<tr valign=middle>
<td>Group name
<td><input type=text name=\"group\" maxlength=32 size=16>
<td><input type=submit name=\"$function\">
</table>
EOD
last FORM;
}
if ($function eq 'ChgGroup') {
print<<EOD;
<table>
<tr valign=middle>
<td>Select group to change
<td><select name="group" size=1>
EOD
foreach $g (sort(keys %groups)) {
  print "<option>$g</option>\n";
}
print<<"EOD";
</select>
<td><input type=submit name=\"$function\">
</table>
EOD
last FORM;
}
if ($function eq 'DelUser') {
print<<EOD;
<table>
<tr valign=middle>
<td>User to delete:
<td><select name="userid">
EOD
foreach $u (sort(keys %users)) {
  print "<option>$u</option>\n";
}
print<<"EOD";
</select>
<td><input type=submit name=\"$function\">
</table>
EOD
last FORM;
}
if ($function eq 'DelGroup') {
print<<EOD;
<table>
<tr valign=middle>
<td>Group to delete:
<td><select name="group">
EOD
foreach $u (sort(keys %groups)) {
  print "<option>$u</option>\n";
}
print<<"EOD";
</select>
<td><input type=submit name=\"$function\">
</table>
EOD
last FORM;
}

print "<P>Unknown function $function.\n";

# End of FORM
}

}
else {

# Examination and execution

EXEC: {
if (exists $cgi{'NewUser'}) {
$userid = $cgi{'userid'};
if (!$userid) {
  print "<P>You must enter a user name.\n";
  last EXEC;
}
if (exists $users{$userid}) {
  print "<P>User <b>$userid</b> already exists.\n";
  last EXEC;
}
if (exists $cgi{'group'}) {
  if (ref($cgi{'group'})) {
    foreach $g (@{$cgi{'group'}}) {
      AddToGroup $userid, $g, \%groups;
    }
  }
  else {
    AddToGroup $userid, $cgi{'group'}, \%groups;
  }
}
if (ChgPasswd $userid, $cgi{'Pass1'}, $cgi{'Pass2'}) {
  WriteGroup $grpfile, \%groups;
}
last EXEC;
}
if (exists $cgi{'ChgUser'}) {
  if ($cgi{'userid'}) {
    ChgPasswd $cgi{'userid'}, $cgi{'Pass1'}, $cgi{'Pass2'};
  }
  else {
    print "<P>You must choose a user.\n";
  }
  last EXEC;
}
if (exists $cgi{'NewGroup'}) {
  $grp = $cgi{'group'};
  if (!$grp) {
    print "<P>You must specify a group name\n.";
    last EXEC;
  }
  if (exists $groups{$grp}) {
    print "<P>Group <b>$grp</b> already exists.\n";
    last EXEC;
  }
  $u[0] = 'Administrator';
  $groups{$grp} = \@u;
  WriteGroup $grpfile, \%groups;
  print "<P>Group <b>$grp</b> created.\n";
  last EXEC;
}
if (exists $cgi{'ChgGroup'}) {
  $grp = $cgi{'group'};
  if (!$grp) {
    print "<P>You must specify a group name\n.";
    last EXEC;
  }
  $uu = $groups{$grp}; # array reference
  my %gu; # hash of group users
  foreach $u (@$uu) {
    $gu{$u} = 1;
  }
print<<"EOD";
<form method=POST action=\"$ENV{'REQUEST_URI'}\">
<P>Select users for group <b>$grp</b>.
<P><select name=\"users\" multiple size=$usrcnt>
EOD
  foreach $u (sort(keys %users)) {
    $o = exists($gu{$u}) ? 'option selected' : 'option';
    print "<$o>$u</option>\n";
  }
print<<"EOD";
</select>
<P><input type=submit name=\"GroupUsers\" value=\"Modify $grp\">
</form>
EOD
  last EXEC;
}
if (exists $cgi{'GroupUsers'}) {
  $cgi{'GroupUsers'} =~ /Modify\s+(.*)$/;  $grp = $1;
  my @uu;
  my $x = $cgi{'users'};
  if (ref($x)) {
    foreach $u (@$x) {
      push @uu, $u;
    }
  }
  else {
    @uu[0] = $x;
  }
  $groups{$grp} = \@uu;
  WriteGroup $grpfile, \%groups;
  print "<P>Group <b>$grp</b> changed.\n";
  last EXEC;
}
if (exists $cgi{'DelUser'}) {
  $userid = $cgi{'userid'};
  if (!$userid) {
    print "<P>You must enter a user name.\n";
    last EXEC;
  }
  open(FILE, ">$usrfile");
  foreach $u (keys %users) {
    print FILE "$u:$users{$u}\n" unless $u eq $userid;
  }
  close FILE;
  foreach $g (keys %groups) {
    my @u;
    foreach $u (@{$groups{$g}}) {
      push (@u, $u) unless $u eq $userid;
    }
    $groups{$g} = \@u;
  }
  WriteGroup $grpfile, \%groups;
  print "<P>User <b>$userid</b> deleted.\n";
  last EXEC;
}
if (exists $cgi{'DelGroup'}) {
  $grp = $cgi{'group'};
  if (!$grp) {
    print "<P>You must specify a group name\n.";
    last EXEC;
  }
  WriteGroup $grpfile, \%groups, $grp;
  print "<P>Group <b>$grp</b> deleted.\n";
  last EXEC;
}

print "What did you submit?\n";
# End of EXEC
}

}
return;
}

sub ChgPasswd {
  my ($user, $pass1, $pass2) = @_;
  my $ret = 0;
  if ($pass1 && ($pass1 eq $pass2)) {
    print "<P>\n", `$pgm $usrfile $user $pass1`, "<P>OK\n";
    $ret = 1;
  }
  else {
    print "<P>The passwords are different!\n";
  }
  return $ret;
}

# ListGroup $grp $contents
# ListGroup $grp \@contents

sub ListGroup {
  my ($grp, $names) = @_;
  $names = join(' ', @$names) if ref($names);
  print "$grp:$names\n";
  return;
}

# AddToGroup $user $grpname \%groups

sub AddToGroup {
  my ($user, $grpname, $groups) = @_;
  my $group = $groups->{$grpname};
  my $found = 0;
  foreach $u (@$group) {
    $found = 1 if $u eq $user;
  }
  push(@$group, $user) unless $found;
}

# WriteGroup $FileName $GroupPtr $GroupToDelete (Optional)

sub WriteGroup {
  my ($FileName, $GroupPtr, $GroupToDelete) = @_;
  open(FILE, ">$FileName");
  select(FILE);
  foreach $g (keys %$GroupPtr) {
    ListGroup $g, $$GroupPtr{$g} unless $g eq $GroupToDelete;
  }
  select(STDOUT);
  close(FILE);
}

__END__

print "<P>Users:\n<ul>\n";
foreach $u (@users) {
  print "<li>$u\n";
}
print "</ul>";

print "<P>Groups:\n<ul>\n";
foreach $g (keys %groups) {
  print "<li>$g\n<ul compact type=square>\n";
  foreach $u (@{$groups{$g}}) {
    print "<li>$u\n";
  }
  print "</ul>\n";
}
print "</ul>\n";
